<template>
  <div id="map"></div>
</template>

<script lang="ts">
import {
  defineComponent,
  computed,
  onMounted,
  ref,
  watch
} from '@nuxtjs/composition-api'
import Button from '@/components/ui/Button.vue'
export default defineComponent<{
  data: any
  result: any
}>({
  name: 'PrivatePage',
  props: ['data', 'result'],
  components: { Button },
  setup(props, { root }) {
    const marker = ref(props.data || [37.617635, 55.755814])

    onMounted(() => {
      setTimeout(createMap, 50)
    })
    const createMap = () => {
      const mapboxgl = require('mapbox-gl')
      require('mapbox-gl/dist/mapbox-gl.css')

      mapboxgl.accessToken =
        'pk.eyJ1IjoiYWxleGtoYXJlY2giLCJhIjoiY2tibnNqc3EyMXZxdjMwcGptcGFjZ3pidCJ9.gGDpAP5xsODsXr2kI6yfUg'
      const map = new mapboxgl.Map({
        container: 'map',
        style: 'mapbox://styles/alexkharech/ckdj217qt152z1itlob2njbl4?v2',
        center: [37.617635, 55.755814],
        zoom: 8
      })

      map.resize()

      map.addControl(
        new mapboxgl.GeolocateControl({
          positionOptions: {
            enableHighAccuracy: true
          },
          trackUserLocation: false
        })
      )

      let geojson = {
        type: 'FeatureCollection',
        features: [
          ...props.result.map((r: any) => ({
            type: 'Feature',
            properties: {
              display_name: r.display_name,
              id: r.id,
              iconSize: [30, 30],
              photo_url: r.avatar_url
            },
            geometry: {
              type: 'Point',
              coordinates: [
                r.location.geo.coordinates[1],
                r.location.geo.coordinates[0]
              ]
            }
          }))
        ]
      }
      geojson.features.forEach(function (marker) {
        var el = document.createElement('div')
        el.className = 'marker'
        el.style.backgroundImage =
          'url(/storage/' + marker.properties.photo_url + ')'
        el.style.width = marker.properties.iconSize[0] + 'px'
        el.style.height = marker.properties.iconSize[1] + 'px'
        el.style.backgroundSize = '100%'

        var popup = new mapboxgl.Popup({ offset: 25 }).setHTML(
          '<a href="users/' +
            marker.properties.id +
            '">' +
            marker.properties.display_name +
            '</a>'
        )

        // add marker to map
        new mapboxgl.Marker(el)
          .setLngLat(marker.geometry.coordinates)
          .setPopup(popup)
          .addTo(map)
      })
    }
    watch(
      () => props.result,
      () => createMap()
    )

    return {}
  }
})
</script>

<style lang="scss" scoped>
@import '~/assets/scss/variables';
#map {
  height: 100vh;
  overflow: hidden;
  @media (min-width: 991.98px) {
    margin: 0px;
    height: calc(100vh - 95px);
  }
  ::v-deep {
    .marker {
      display: block;
      border: none;
      border-radius: 50%;
      cursor: pointer;
      padding: 0;
    }
    .mapboxgl-ctrl-group {
      background: 0;
      border: 0;
      outline: none !important;
      box-shadow: none !important;
      margin: 20px 20px 0 0;
    }
    .mapboxgl-ctrl-geolocate {
      width: auto;
      height: auto;
      background: $--color-primary;
      border-radius: 50%;
      font-size: 0px;
      border: 0;
      border-radius: 50%;
      padding: 15px;
      span {
        width: 18px;
        height: 18px;
        background-image: url(~@/assets/icons/gps.svg);
      }
    }
    .mapboxgl-popup-content {
      background: #1f232f;
      font-family: 'TT Interfaces', serif;
      font-size: 16px;
      font-weight: 500;
      padding: 20px;
    }
    .mapboxgl-popup-close-button {
      color: #9badd6;
    }
    .mapboxgl-popup-anchor-bottom .mapboxgl-popup-tip {
      border-top-color: #1f232f;
    }
    .mapboxgl-popup-anchor-top .mapboxgl-popup-tip {
      border-bottom-color: #1f232f;
    }
    .mapboxgl-popup-anchor-left .mapboxgl-popup-tip {
      border-right-color: #1f232f;
    }
    .mapboxgl-popup-anchor-right .mapboxgl-popup-tip {
      border-left-color: #1f232f;
    }
  }
}
</style>
